<?php
/**
 * @package		Earnings Dashboard - Module for Joomla!
 * @author		DeConf - http://deconf.com
 * @copyright	Copyright (c) 2010 - 2012 DeConf.com
 * @license		GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' ); 
 
class AdSenseAuth {
protected $apiClient;
protected $adSenseService;
private $user;

public function __construct($params) {

		$scriptUri = "http://".$_SERVER["HTTP_HOST"].$_SERVER['PHP_SELF'];

		$this->apiClient = new Google_Client();
		$this->apiClient->setClientId($params->get('gads_client_id'));
		$this->apiClient->setClientSecret($params->get('gads_client_secret'));
		$this->apiClient->setDeveloperKey($params->get('gads_api_key'));
		$this->apiClient->setRedirectUri($scriptUri);
		$this->adSenseService = new Google_AdSenseService($this->apiClient);	
}

	function getToken (){

		$db = JFactory::getDBO();
		$query = "SELECT token FROM #__gads_dash";
		$db->setQuery($query);		
		$result = $db->loadResult();
		
		return $result;
	
	}

	function saveToken ($user, $token){
		
		$db = JFactory::getDBO();
		$query = "UPDATE #__gads_dash SET token='$token' WHERE user='$user';";
		$db->setQuery($query);
		$result = $db->query();
		
		if (!$result){
			
			$query = "CREATE TABLE IF NOT EXISTS #__gads_dash (user VARCHAR(255) NOT NULL , token VARCHAR(255) NOT NULL);";
			$db->setQuery($query);
			$result = $db->query();		

			$query = "INSERT INTO #__gads_dash (user, token) VALUES ('$user', '$token');";
			$db->setQuery($query);
			$result = $db->query();		
		}
	
	}		  
	
	function authenticate($user) {
		$this->user=$user;
		$token = $this->getToken();
		if (isset($token)) {
		  $this->apiClient->setAccessToken($token);
		} else {
			$this->apiClient->setScopes(array("https://www.googleapis.com/auth/adsense.readonly"));
			if (!isset($_REQUEST['authorize']) AND !isset($_REQUEST['code'])){
				return '<div style="padding:20px;"><form name="input" action="#" method="get">
				<input type="submit" name="authorize" value="'.JText::_('GADS_AUTHORIZE').'"/>
			</form></div>';
			}		
			else if (isset($_REQUEST['code'])) {
			  $this->apiClient->authenticate();
			  $this->saveToken($this->user, $this->apiClient->getAccessToken());

			}
			else{
			
			  $authUrl = $this->apiClient->createAuthUrl();
			  header("Location: ".$authUrl);
			  die;	

		}

		}
	}
	
	function getAdSenseService() {
		return $this->adSenseService;
	}
	
	function refreshToken() {
		if ($this->apiClient->getAccessToken() != null) {
			$this->saveToken('default', $this->apiClient->getAccessToken());
		}
	}	

}
 
 class modGoogleAdsenseEarningsHelper
{

    function gads_generate_code( $params ){
		
		if (!class_exists('Google_Client')){

			
			require_once dirname(__FILE__).'/src/Google_Client.php';
		}		
		
		require_once dirname(__FILE__).'/src/contrib/Google_AdsenseService.php';
		
		if ((!$params->get('gads_client_id')) OR (!$params->get('gads_client_secret')) OR (!$params->get('gads_api_key'))){
			
			return "<div style='padding:20px;'>".JText::_('GADS_MISSING')."</div>";
			
		}	
		
		$auth = new AdSenseAuth($params);
		$result=$auth->authenticate('default');
		
		if ($result){
		
			return $result;
		
		}
		
		$adSense=$auth->getAdSenseService();


		$query_adsense = (!isset($_REQUEST['query_adsense'])) ? "EARNINGS" : $_REQUEST['query_adsense'];
		$period_adsense = (!isset($_REQUEST['period_adsense'])) ? "last30days" : $_REQUEST['period_adsense'];
		
		switch ($period_adsense){

			case 'today'	:	$from = date('Y-m-d'); 
								$to = date('Y-m-d');
								break;

			case 'yesterday'	:	$from = date('Y-m-d', time()-24*60*60);
									$to = date('Y-m-d', time()-24*60*60);
									break;
			
			case 'last7days'	:	$from = date('Y-m-d', time()-7*24*60*60);
								$to = date('Y-m-d');
								break;	

			case 'last14days'	:	$from = date('Y-m-d', time()-14*24*60*60);
								$to = date('Y-m-d');
								break;	
								
			default	:	$from = date('Y-m-d', time()-30*24*60*60);
						$to = date('Y-m-d');
						break;

		}

		switch ($query_adsense){

			case 'COST_PER_CLICK'	:	$title=JText::_('GADS_COST_PER_CLICK'); break;

			case 'CLICKS'	:	$title=JText::_('GADS_CLICKS'); break;	

			case 'PAGE_VIEWS'	:	$title=JText::_('GADS_PAGE_VIEWS'); break;

			case 'PAGE_VIEWS_CTR'	:	$title=JText::_('GADS_PAGE_VIEWS_CTR'); break;
			
			case 'PAGE_VIEWS_RPM'	:	$title=JText::_('GADS_PAGE_VIEWS_RPM'); break;			
			
			default	:	$title=JText::_('GADS_EARNINGS');

		}

		$optParams = array(
		  'metric' => array($query_adsense),
		  'dimension' => 'DATE',
		  'sort' => 'DATE'
		);
		try{
			$data = $adSense->reports->generate($from, $to, $optParams);
		}  
			catch(exception $e) {
			return "<br />ERROR LOG:<br /><br />".$e; 
		}
		$chart1_data = "";
		for ($i=0;$i<$data['totalMatchedRows'];$i++){
			if ($query_adsense=='PAGE_VIEWS_CTR')
				$chart1_data.="['".$data['rows'][$i][0]."',".($data['rows'][$i][1]*100)."],";
			else
				$chart1_data.="['".$data['rows'][$i][0]."',".$data['rows'][$i][1]."],";

		}

		$optParams = array(
		  'metric' => array(
			'EARNINGS', 'COST_PER_CLICK', 'CLICKS', 'PAGE_VIEWS', 'PAGE_VIEWS_CTR',  'PAGE_VIEWS_RPM'
		  ),
		  'dimension' => 'YEAR'
		);
		$data = $adSense->reports->generate($from, $to, $optParams);

    $code='<script type="text/javascript" src="https://www.google.com/jsapi"></script>
    <script type="text/javascript">
      google.load("visualization", "1", {packages:["corechart"]});
	  google.setOnLoadCallback(adsense_drawChart1);
       	  
      function adsense_drawChart1() {
        var data = google.visualization.arrayToDataTable(['."
          ['".JText::_('GADS_DATE')."', '".$title."'],"
		  .$chart1_data.
		"  
        ]);

        var options = {
		  legend: {position: 'none'},	
		  pointSize: 3,
		  colors:['red','#004411'],
          title: '".$title."',titleTextStyle: {color: '#000000'},
		  chartArea: {width: '80%', height: '50%'},
          hAxis: { title: '".JText::_('GADS_DATE')."',  titleTextStyle: {color: 'red'}, showTextEvery: 5}
		};

        var chart = new google.visualization.AreaChart(document.getElementById('adsense_chart1_div'));
		chart.draw(data, options);
		
      }

    </script>".'
	<div id="gads-dash">
	<center>
		<div id="buttons_div_adsense">
		<center>
			<input class="gadsbutton" type="button" value="'.JText::_('GADS_TODAY').'" onClick="window.location=\'?period_adsense=today&query_adsense='.$query_adsense.'\'" />
			<input class="gadsbutton" type="button" value="'.JText::_('GADS_YESTERDAY').'" onClick="window.location=\'?period_adsense=yesterday&query_adsense='.$query_adsense.'\'" />
			<input class="gadsbutton" type="button" value="'.JText::_('GADS_LAST7DAYS').'" onClick="window.location=\'?period_adsense=last7days&query_adsense='.$query_adsense.'\'" />
			<input class="gadsbutton" type="button" value="'.JText::_('GADS_LAST14DAYS').'" onClick="window.location=\'?period_adsense=last14days&query_adsense='.$query_adsense.'\'" />
			<input class="gadsbutton" type="button" value="'.JText::_('GADS_LAST30DAYS').'" onClick="window.location=\'?period_adsense=last30days&query_adsense='.$query_adsense.'\'" />
		</center>
		</div>
		
		<div id="adsense_chart1_div"></div>
		
		<div id="adsense_details_div">
			<center>
			<table class="adsensetable" cellpadding="4">
			<tr>
			<td width="24%">'.JText::_('GADS_EARNINGS').':</td>
			<td width="12%" class="adsensevalue"><a href="?query_adsense=EARNINGS&period_adsense='.$period_adsense.'" class="adsensetable">'.$data['rows'][0][0].'</td>
			<td width="24%">'.JText::_('GADS_CPC').':</td>
			<td width="12%" class="adsensevalue"><a href="?query_adsense=COST_PER_CLICK&period_adsense='.$period_adsense.'" class="adsensetable">'.$data['rows'][0][1].'</a></td>
			<td width="24%">'.JText::_('GADS_CLICKS').':</td>
			<td width="12%" class="adsensevalue"><a href="?query_adsense=CLICKS&period_adsense='.$period_adsense.'" class="adsensetable">'.$data['rows'][0][2].'</a></td>
			</tr>
			<tr>
			<td>'.JText::_('GADS_PAGE_VIEWS').':</td>
			<td class="adsensevalue"><a href="?query_adsense=PAGE_VIEWS&period_adsense='.$period_adsense.'" class="adsensetable">'.$data['rows'][0][3].'</a></td>
			<td>'.JText::_('GADS_CTR').':</td>
			<td class="adsensevalue"><a href="?query_adsense=PAGE_VIEWS_CTR&period_adsense='.$period_adsense.'" class="adsensetable">'.($data['rows'][0][4]*100).'</a></td>
			<td>'.JText::_('GADS_RPM').':</td>
			<td class="adsensevalue"><a href="?query_adsense=PAGE_VIEWS_RPM&period_adsense='.$period_adsense.'" class="adsensetable">'.$data['rows'][0][5].'</a></td>
			</tr>
			</table>
			</center>		
		</div>
	</center>		
	</div>';
		return $code;
    
	}
}
?>
